---
title: Optional chaining (?.)
slug: Web/JavaScript/Reference/Operators/Optional_chaining
tags:
  - Chaining
  - JavaScript
  - Language feature
  - Operator
  - Optional chaining
  - Reference
---
<div>{{JSSidebar("Operators")}}</div>

<p>The <strong>optional chaining</strong> operator (<strong><code>?.</code></strong>) permits reading the value of a property located deep within a chain of connected objects without having to expressly validate that each reference in the chain is valid. <span class="seoSummary">The <code>?.</code> operator functions similarly to the <code>.</code> chaining operator, except that instead of causing an error if a reference is <a href="/en-US/docs/Glossary/nullish">nullish</a> ({{JSxRef("null")}} or {{JSxRef("undefined")}}), the expression short-circuits with a return value of <code>undefined</code>.</span> When used with function calls, it returns <code>undefined</code> if the given function does not exist.</p>

<p>This results in shorter and simpler expressions when accessing chained properties when the possibility exists that a reference may be missing. It can also be helpful while exploring the content of an object when there's no known guarantee as to which properties are required.</p>

<p>Optional chaining cannot be used on a non-existent root object. It does not replace checks like <code>if (typeof a == "undefined")</code>.</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-optionalchainingoperator.html", "taller")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><var>obj.val</var>?.<var>prop</var>
<var>obj.val</var>?.[<var>expr</var>]
<em>obj.arr</em>?.[<var>index</var>]
<var>obj.func</var>?.(<var>args</var>)
</pre>

<h2 id="Description">Description</h2>

<p>The optional chaining operator provides a way to simplify accessing values through connected objects when it's possible that a reference or function may be <code>undefined</code> or <code>null</code>.</p>

<p>For example, consider an object <code>obj</code> which has a nested structure. Without optional chaining, looking up a deeply-nested subproperty requires validating the references in between, such as:</p>

<pre class="brush: js notranslate">let nestedProp = obj.first &amp;&amp; obj.first.second;</pre>

<p>The value of <code>obj.first</code> is confirmed to be non-<code>null</code> (and non-<code>undefined</code>) before then accessing the value of <code>obj.first.second</code>. This prevents the error that would occur if you accessed <code>obj.first.second</code> directly without testing <code>obj.first</code>.</p>

<p>With the optional chaining operator (<code>?.</code>), however, you don't have to explicitly test and short-circuit based on the state of <code>obj.first</code> before trying to access <code>obj.first.second</code>:</p>

<pre class="brush: js notranslate">let nestedProp = obj.first?.second;</pre>

<p>By using the <code>?.</code> operator instead of just <code>.</code>, JavaScript knows to implicitly check to be sure <code>obj.first</code> is not <code>null</code> or <code>undefined</code> before attempting to access <code>obj.first.second</code>. If <code>obj.first</code> is <code>null</code> or <code>undefined</code>, the expression automatically short-circuits, returning <code>undefined</code>.</p>

<p>This is equivalent to the following, except that the temporary variable is in fact not created:</p>

<pre class="brush: js notranslate">let temp = obj.first;
let nestedProp = ((temp === null || temp === undefined) ? undefined : temp.second);
</pre>

<h3 id="Optional_chaining_with_function_calls">Optional chaining with function calls</h3>

<p>You can use optional chaining when attempting to call a method which may not exist. This can be helpful, for example, when using an API in which a method might be unavailable, either due to the age of the implementation or because of a feature which isn't available on the user's device.</p>

<p>Using optional chaining with function calls causes the expression to automatically return <code>undefined</code> instead of throwing an exception if the method isn't found:</p>

<pre class="brush: js notranslate">let result = someInterface.customMethod?.();</pre>

<div class="notecard note">
<p><strong>Note:</strong> If there is a property with such a name and which is not a function, using <code>?.</code> will still raise a {{JSxRef("TypeError")}} exception (<code>someInterface.customMethod is not a function</code>).</p>
</div>

<div class="notecard note">
<p><strong>Note:</strong> If <code>someInterface</code> itself is <code>null</code> or <code>undefined</code>, a {{JSxRef("TypeError")}} exception will still be raised (<code>someInterface is null</code>). If you expect that <code>someInterface</code> itself may be <code>null</code> or <code>undefined</code>, you have to use <font face="consolas, Liberation Mono, courier, monospace"><span style="background-color: rgba(220, 220, 220, 0.5);">?.</span></font> at this position as well: <code>someInterface?.customMethod?.()</code></p>
</div>

<h4 id="Dealing_with_optional_callbacks_or_event_handlers">Dealing with optional callbacks or event handlers</h4>

<p>If you use callbacks or fetch methods from an object with <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Destructuring_assignment#Object_destructuring">a destructuring assignment</a>, you may have non-existent values that you cannot call as functions unless you have tested their existence. Using <code>?.</code>, you can avoid this extra test:</p>

<pre class="brush: js notranslate">// Written as of ES2019
function doSomething(onContent, onError) {
  try {
    // ... do something with the data
  }
  catch (err) {
    if (onError) { // Testing if onError really exists
      onError(err.message);
    }
  }
}
</pre>

<pre class="brush: js notranslate">// Using optional chaining with function calls
function doSomething(onContent, onError) {
  try {
   // ... do something with the data
  }
  catch (err) {
    onError?.(err.message); // no exception if onError is undefined
  }
}
</pre>

<h3 id="Optional_chaining_with_expressions">Optional chaining with expressions</h3>

<p>You can also use the optional chaining operator when accessing properties with an expression using <a href="/en-US/docs/Web/JavaScript/Reference/Operators/Property_Accessors#Bracket_notation">the bracket notation of the property accessor</a>:</p>

<pre class="brush: js notranslate">let nestedProp = obj?.['prop' + 'Name'];
</pre>

<h3 id="Optional_chaining_not_valid_on_the_left-hand_side_of_an_assignment">Optional chaining not valid on the left-hand side of an assignment</h3>

<pre class="brush: js notranslate"><code>let object = {};
object?.property = 1; // Uncaught SyntaxError: Invalid left-hand side in assignment</code></pre>

<h3 id="Array_item_access_with_optional_chaining">Array item access with optional chaining</h3>

<pre class="brush: js notranslate">let arrayItem = arr?.[42];</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Basic_example">Basic example</h3>

<p>This example looks for the value of the <code>name</code> property for the member <code>bar</code> in a map when there is no such member. The result is therefore <code>undefined</code>.</p>

<pre class="brush: js notranslate">let myMap = new Map();
myMap.set("foo", {name: "baz", desc: "inga"});

let nameBar = myMap.get("bar")?.name;</pre>

<h3 id="Short-circuiting_evaluation">Short-circuiting evaluation</h3>

<p>When using optional chaining with expressions, if the left operand is <code>null</code> or <code>undefined</code>, the expression will not be evaluated. For instance:</p>

<pre class="brush: js notranslate">let potentiallyNullObj = null;
let x = 0;
let prop = potentiallyNullObj?.[x++];

console.log(x); // 0 as x was not incremented
</pre>

<h3 id="Stacking_the_optional_chaining_operator">Stacking the optional chaining operator</h3>

<p>With nested structures, it is possible to use optional chaining multiple times:</p>

<pre class="brush: js notranslate">let customer = {
  name: "Carl",
  details: {
    age: 82,
    location: "Paradise Falls" // detailed address is unknown
  }
};
let customerCity = customer.details?.address?.city;

// … this also works with optional chaining function call
let customerName = customer.name?.getName?.(); // method does not exists, customerName is undefined
</pre>

<h3 id="Combining_with_the_nullish_coalescing_operator">Combining with the nullish coalescing operator</h3>

<p>The {{JSxRef("Operators/Nullish_Coalescing_Operator", "nullish coalescing operator", '', 1)}} may be used after optional chaining in order to build a default value when none was found:</p>

<pre class="brush: js notranslate">let customer = {
  name: "Carl",
  details: { age: 82 }
};
const customerCity = customer?.city ?? "Unknown city";
console.log(customerCity); // Unknown city</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('ESDraft', '#prod-OptionalExpression', 'optional expression')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("javascript.operators.optional_chaining")}}</p>
</div>

<h3 id="Implementation_Progress">Implementation Progress</h3>

<p>The following table provides a daily implementation status for this feature because this feature has not yet reached cross-browser stability. The data is generated by running the relevant feature tests in <a href="https://github.com/tc39/test262">Test262</a>, the standard test suite of JavaScript, in the nightly build, or the latest release of each browser's JavaScript engine.</p>

<div>{{EmbedTest262ReportResultsTable("optional-chaining")}}</div>

<h2 id="See_also">See also</h2>

<ul>
 <li>The {{JSxRef("Operators/Nullish_Coalescing_Operator", "Nullish Coalescing Operator", '', 1)}}</li>
</ul>
